#ifndef GLOBAL_H
#define GLOBAL_H

// --- Includes ---
#include <avr/interrupt.h>
#include <avr/io.h>

// --- Definitionen ---
#define ABS(x)   ( (x) >  (0) ? (x) :-(x) )
#define NEG(x)   ( (x) <  (0) ? (x) :-(x) )
#define MAX(x,y) ( (x) >= (y) ? (x) : (y) )
#define MIN(x,y) ( (x) <= (y) ? (x) : (y) )
#define BV(x)    ( 1 << x )

#define IELOCK    cli(); \
                  IeLock++;
#define IEUNLOCK  IeLock--; \
                  if (!IeLock)\
                  sei ();

  // --- Typen ---
  typedef char s8;
  typedef short s16;
  typedef long s32;
  typedef long long s64;
  typedef unsigned char u8;
  typedef unsigned short u16;
  typedef unsigned long u32;
  typedef unsigned long long u64;
  typedef u8 byte;
  typedef u16 word;
  typedef u8 boolean;
  enum {FALSE, TRUE};

  struct sTimer
  {
    u16  counter;
    boolean running;
  };

  // --- Variablen ---
  extern volatile struct sTimer timer_delay;
  extern u8 IeLock;

  // --- Prototypen ---
  void msdelay(u16 msec);
  void usdelay(register u8 usec);



#endif
