//==================================================================================
// Projekt    : XPort Webserver
// Verfasser  : Thomas Berger
// Erstellt   : 15.05.2006
// Stand      : 28.05.2006, Version 1.0 tb
// Status     : Beta
//==================================================================================


// --- Includes ---
#include <avr/interrupt.h>

#include "global.h"
#include "web.h"

// --- Variablen ---
struct sTimer SerialTimer;
u16 SekTimer=0;

//-------------------------------------------------------------------------
// Zhler1 hat seinen Compare-Wert erreicht
//-------------------------------------------------------------------------
SIGNAL (SIG_OUTPUT_COMPARE1A){

  // --- Delay ---
  if ( timer_delay.running )
  {
    if ( !timer_delay.counter-- )
    {
      timer_delay.running = FALSE;
    }
  }
  
  // --- Serial Delay ---
  if ( SerialTimer.running )
  {
    if ( !SerialTimer.counter-- )
    {
      SerialTimer.running = FALSE;
      web_init();
      web_sendchar();
    }
  }

  // --- Serial Delay ---
  SekTimer++;
  if ( SekTimer > 9999 ){
    SekTimer = 0;
    IncUptime();
  }



}


//-------------------------------------------------------------------------
//  Ein Byte wurde gesendet
//-------------------------------------------------------------------------
SIGNAL (SIG_UART_TRANS){
  web_sendchar();
}

//-------------------------------------------------------------------------
//  Ein Byte wurde empfangen
//-------------------------------------------------------------------------
SIGNAL (SIG_UART_RECV){
  u8 c;
  c = UDR;

  SerialTimer.counter = 4000;
  SerialTimer.running = TRUE;
}

//-------------------------------------------------------------------------
//  INT0
//-------------------------------------------------------------------------
SIGNAL (SIG_INTERRUPT0){

}
//-------------------------------------------------------------------------
//  INT1
//-------------------------------------------------------------------------
SIGNAL (SIG_INTERRUPT1){

}
