//==================================================================================
// Projekt    : XPort Webserver
// Verfasser  : Thomas Berger
// Erstellt   : 15.05.2006
// Stand      : 28.05.2006, Version 1.0 tb
// Status     : Beta
//==================================================================================

// --- Includes ---
#include <string.h>
#include <stdlib.h>
#include <avr/pgmspace.h>

#include "global.h"
#include "adc.h"


char Header[] = {"\
HTTP/1.0 200 OK\r\n\
Content-type:text/html\r\n\
Content-Length: $SIZE\r\n\
Connection: Close\r\n\
\r\n\
"};



char Page[] = {
"<html><head><title>XPort Webserver 1.0beta</title>\
</head>\n\
<body bgcolor=\"#507EAE\">\
<font size=\"5\" face=\"helvetica,arial\" color=\"#FFFFFF\">\
<b>XPort Webserver, 1.0beta</b><br><br>\
Uptime: $UPTIME s<br><br>\
ADC0: $ADC0<br>\
ADC1: $ADC1<br>\
ADC2: $ADC2<br>\
ADC3: $ADC3<br>\
ADC4: $ADC4<br>\
ADC5: $ADC5<br>\
</font>\
</body></html>\n"
};


#define ADCCHANELSIZE 6
volatile u32 UpTime=0;
u16 ContentLength=0;
u16 ADCVal[ADCCHANELSIZE];


#define BUFSIZE 500
char Buffer[BUFSIZE];
u16 Sequenz =0;
u16 sercnt = 0;
u16 Size = 0;



#define COMMANDSIZE 8
char *Commands[] = {
"$UPTIME",
"$SIZE",
"$ADC0",
"$ADC1",
"$ADC2",
"$ADC3",
"$ADC4",
"$ADC5"
};


//-------------------------------------------------------------------------
// Uptime verwalten
//-------------------------------------------------------------------------
void IncUptime(void){
  UpTime++;
}


//-------------------------------------------------------------------------
// ADC Array auslesen
//-------------------------------------------------------------------------
void GetADC(void){
  u8 i;

  for (i=0; i<ADCCHANELSIZE; i++){
    ADCVal[i] = ADC_GetChn(i);
  }
}


//-------------------------------------------------------------------------
// String nach einem Kommando ($) durchsuchen
//-------------------------------------------------------------------------
s16 ScanForCMD(char *buf, u16 StartPos, u16 maxsize){
  u16 i;

  for (i=StartPos; i<maxsize; i++){
    if(buf[i]=='$'){
      return i;
    }
  }

  return -1;
}


//-------------------------------------------------------------------------
// Kommando indentifizieren
//-------------------------------------------------------------------------
s16 ParseCMD(char *buf, u16 maxsize, u16 pos){
  u16 i;
  for(i=0;i<COMMANDSIZE;i++){ 
    if (!strncasecmp(Commands[i], &buf[pos], strlen(Commands[i]) ) ){
      return i;
    }
  }
  return -1;
}

//-------------------------------------------------------------------------
// Sting zusammenstellen
//-------------------------------------------------------------------------
u16 BuildString(char *Msg){
  char tmptxt[20];
  u16 maxsize = strlen(Msg);
  s16 position = 0;
  s16 positionAlt = 0;
  s16 Cmd = 0;

  do{
    positionAlt = position;
    position = ScanForCMD(Msg, positionAlt, maxsize);

    strncat(Buffer, Msg+positionAlt, position-positionAlt);

    if ((position >= 0) && (position < maxsize)){
      Cmd = ParseCMD(Msg, maxsize, position);
      if (Cmd >=0){
        position += strlen(Commands[Cmd]);
      }else{
        position +=1;
      }
      switch(Cmd){
        case 0:
          itoa(UpTime, tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 1:
          itoa(ContentLength, tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 2:
          itoa(ADCVal[0], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 3:
          itoa(ADCVal[1], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 4:
          itoa(ADCVal[2], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 5:
          itoa(ADCVal[3], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 6:
          itoa(ADCVal[4], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        case 7:
          itoa(ADCVal[5], tmptxt, 10); 
          strcat(Buffer, tmptxt) ;
        break;
        default:
          strcat(Buffer, "?") ;
        break;
      } 
    }else{
       break;
    }
  }while (1); 


  return strlen(Buffer);
}



//-------------------------------------------------------------------------
// Variablen initialisieren
//-------------------------------------------------------------------------
void web_init(void){
  Sequenz=0;
  sercnt=0;

  GetADC();

  memset(Buffer, 0x00, BUFSIZE);
  ContentLength = BuildString(Page);

  memset(Buffer, 0x00, BUFSIZE);
  Size = BuildString(Header);
}

//-------------------------------------------------------------------------
// Ein Zeichen senden
//-------------------------------------------------------------------------
void web_sendchar(void){
  switch(Sequenz){
    case 0:
      UDR = Buffer[sercnt];
      sercnt++;
      if (sercnt >=Size){
        Sequenz++;
        sercnt = 0;
        memset(Buffer, 0x00, BUFSIZE);
        Size = BuildString(Page);
      }
    break;
    case 1:
      UDR = Buffer[sercnt];
      sercnt++;
      if (sercnt >=Size){
        Sequenz++;
      }
    break;
    default:
      return;
    break;
  }
}


